Summary:          Realtime Policy and Watchdog Daemon
Name:             rtkit
Version:          0.11
Release:          3%{?dist}
License:          GPLv3+ and BSD
URL:              http://git.0pointer.net/rtkit.git/
Source0:          http://0pointer.de/public/%{name}-%{version}.tar.xz

Patch3000:        rtkit-mq_getattr.patch
Patch3001:        0001-SECURITY-Pass-uid-of-caller-to-polkit.patch
Patch3002:        rtkit-controlgroup.patch
Patch3003:        format-security.patch
Patch3004:        0001-Fix-borked-error-check.patch
Patch3005:        0001-systemd-update-sd-daemon.-ch.patch
Patch3006:        0002-Remove-bundled-copy-of-sd-daemon.-ch.patch
Patch3007:        remove-debug-messages.patch

BuildRequires:    autoconf automake libtool make
BuildRequires:    systemd-devel polkit-devel dbus-devel >= 1.2
BuildRequires:    libcap-devel

Requires:         dbus
Requires:         polkit

%description
RealtimeKit is a D-Bus system service that changes the
scheduling policy of user processes/threads to SCHED_RR (i.e. realtime
scheduling mode) on request. It is intended to be used as a secure
mechanism to allow real-time scheduling to be used by normal user
processes.

%prep
%autosetup -p1

%build
autoreconf -fvi
%configure --with-systemdsystemunitdir=%{_unitdir}
%make_build
./rtkit-daemon --introspect > org.freedesktop.RealtimeKit1.xml

%install
%make_install
install -Dm0644 org.freedesktop.RealtimeKit1.xml %{buildroot}%{_datadir}/dbus-1/interfaces/org.freedesktop.RealtimeKit1.xml

%pre
getent group rtkit >/dev/null 2>&1 || groupadd \
        -r \
        -g 172 \
        rtkit
getent passwd rtkit >/dev/null 2>&1 || useradd \
        -r -l \
        -u 172 \
        -g rtkit \
        -d /proc \
        -s /sbin/nologin \
        -c "RealtimeKit" \
        rtkit
:;

%post
%systemd_post rtkit-daemon.service
dbus-send --system --type=method_call --dest=org.freedesktop.DBus / org.freedesktop.DBus.ReloadConfig >/dev/null 2>&1 || :

%preun
%systemd_preun rtkit-daemon.service

%postun
%systemd_postun_with_restart rtkit-daemon.service

%files
%doc README GPL LICENSE rtkit.c rtkit.h
%attr(0755,root,root) %{_sbindir}/rtkitctl
%attr(0755,root,root) %{_libexecdir}/rtkit-daemon
%{_datadir}/dbus-1/system-services/org.freedesktop.RealtimeKit1.service
%{_datadir}/polkit-1/actions/org.freedesktop.RealtimeKit1.policy
%{_datadir}/dbus-1/interfaces/org.freedesktop.RealtimeKit1.xml
%config(noreplace) %{_sysconfdir}/dbus-1/system.d/org.freedesktop.RealtimeKit1.conf
%{_prefix}/lib/systemd/system/rtkit-daemon.service
%{_mandir}/man8/*

%changelog
* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.11-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.11-2
- Rebuilt for OpenCloudOS Stream 23

* Wed Nov 30 2022 cunshunxia <cunshunxia@tencent.com> - 0.11-1
- initial build
